program duration
    
  use mtime

  implicit none

  call setCalendar(proleptic_gregorian)

  call testTimedelta('PT12H', 'PT12H')
  call testTimedelta('PT06H', 'PT06H')
  call testTimedelta('PT6H', 'PT06H')
  call testTimedelta('PT2M', 'PT02M')
  call testTimedelta('PT01H', 'PT01H')
  call testTimedelta('P01M', 'P01M')
  call testTimedelta('P2M', 'P02M')
  call testTimedelta('PT10S', 'PT10.000S')
  call testTimedelta('PT1S', 'PT01.000S')
  call testTimedelta('PT100S', 'PT01M40.000S')
  call testTimedelta('PT100.5S', 'PT01M40.500S')
  call testTimedelta('PT934565S', 'P10DT19H36M05.000S')
  call testTimedelta('P02DT06H', 'P02DT06H')
  call testTimedelta('P2DT6H', 'P02DT06H')
  call testTimedelta('P200D', 'P200D')

  call testTimedeltaComp('PT24M', 'PT06H00M00S', '<', .TRUE.) 

contains

  subroutine testTimedeltaComp(td_A, td_B, op, expected)
    character(len=*), intent(in) :: td_a
    character(len=*), intent(in) :: td_b
    character(len=*), intent(in) :: op
    logical, intent(in) :: expected

    TYPE(timedelta),     POINTER   :: mtime_A, mtime_B

    mtime_A => newTimedelta(td_a)
    mtime_B => newTimedelta(td_b)

    select case (op)
    case ('<')
      print *, td_a, ' < ', td_b, ' ? ', mtime_A < mtime_B, ' expected ', expected      
    case default
      print *, 'Unknown comparison operator.'
    end select
    
  end subroutine testTimedeltaComp
  
  subroutine testTimedelta(interval, expected)
    character(len=*), intent(in) :: interval, expected
    character(len=max_timedelta_str_len) :: dstring
    character(len=max_mtime_error_str_len) :: estring
    type(timedelta), pointer :: d
    integer :: error 
    d => newTimedelta(trim(interval))
    error = 0
    call timedeltaToString(d, dstring, error)
    if (error /= no_error) then
      call mtime_strerror(error, estring)
      print *, 'ERROR: ', trim(estring), ' input: ', trim(interval)
    else
      print *, 'timedelta: input ', trim(interval), ' expected ', trim(expected), ': ', trim(dstring)
    endif
    call deallocateTimedelta(d)
  end subroutine testTimedelta

end program duration
